/************************************************************************
* Rutoken                                                               *
* Copyright (C) Aktiv Co. 2003 - 2011                                   *
*  :  http://www.rutoken.ru                          *
*  :    http://www.rutoken.ru/hotline/download/drivers/*
*  : http://www.rutoken.ru/hotline/                 *
*-----------------------------------------------------------------------*
*               *
*     Rutoken    Cert2Cont:          *
*  -     ;                               * 
*  -  ,    ;                 *
*  -    ;                                       *
*  -   .                              *
************************************************************************/
    

#ifndef _UTIL_FUNCS_H
#define _UTIL_FUNCS_H


/************************************************************************
*                                                 *
************************************************************************/
void PrintWelcomeInformation();

/************************************************************************
*                                        *
************************************************************************/
void PrintHelpInformation();

/************************************************************************
*  ,                 *
************************************************************************/
bool ParseCommandLine(   IN  int     argc,              //       
                         IN  _TCHAR* argv[],            //      
                         OUT LPTSTR& lpszCSP,           //   ,   
                         OUT LPTSTR& lpszContainer,     //   ,   
                         OUT DWORD&  dwKeySpec,         //   
                         OUT LPTSTR& lpszCertFileName,  //   ,       
                         OUT bool&   bPrintHelpAndExit  //  true,        
                      );

/************************************************************************
*  ,    ,           *
*                                             *
************************************************************************/
void FreeCommandLineParameters( IN OUT LPTSTR& lpszCSP,          //   ,   . ,   ,   
                                IN OUT LPTSTR& lpszContainer,    //   ,   . ,   ,   
                                IN OUT DWORD&  dwKeySpec,        //   .     0
                                IN OUT LPTSTR& lpszCertFileName  //   ,       . ,   ,  
                              );

/************************************************************************
*                                               *
************************************************************************/
bool ReadCertificateFromFile( IN  LPCTSTR lpszPreferredFile, //   ,       
                              OUT LPVOID& lpvCertBuffer,     //   ,      
                              OUT DWORD&  dwCertBufferSize   //  ,   ,  
                             );

/************************************************************************
*  ,             *
************************************************************************/
void FreePointersList( IN LPVOID* lppvPointersList, //      
                       IN DWORD   dwPointersCount   //    
                     );

/************************************************************************
*                                                      *
************************************************************************/
void FreeBuffer( IN OUT LPVOID* lppvBuffer //       
                );

/************************************************************************
*                                           *
************************************************************************/
void PrintErrorText( IN LPTSTR lpszText, //     
                     IN DWORD  dwError   //  
					);

#endif                    // _UTIL_FUNCS_H