/************************************************************************
* Rutoken                                                               *
* Copyright (C) Aktiv Co. 2003 - 2011                                   *
*  :  http://www.rutoken.ru                          *
*  :    http://www.rutoken.ru/hotline/download/drivers/*
*  : http://www.rutoken.ru/hotline/                 *
*-----------------------------------------------------------------------*
*                     *
*      Rutoken       * 
* PKCS#11   C++:                                                 *
*  -   ;                                        *
*  -     ;                            *
*  -       ;                  *
*  -       .                   *
************************************************************************/
    

#ifndef COMMON_H
#define COMMON_H


#include <stdio.h>
#include <Windows.h>
#include <WinCrypt.h>
#include <process.h>
#include <time.h>
#include <tchar.h>

    
/*    */
#define TEMP_BUFFER_SIZE    1000

/*    */
#define arraysize(a)        (sizeof(a)/sizeof(a[0]))

/************************************************************************
*                           *
************************************************************************/
void GenerateRandomData( IN  DWORD   dwDataSize,  //        
                         OUT PBYTE&  pbtData      //   ,                                
                        );

/************************************************************************
*                                               *
************************************************************************/
void PrintBuffer( IN PBYTE pbtData,    //    c 
                  IN DWORD dwDataSize  //      
                 );

/************************************************************************
*      ,  ANSI             *
************************************************************************/
void PrintBufferAsCharString( IN LPTSTR   lpszText,   //      
                              IN PBYTE    pbtData,    //    c 
                              IN DWORD    dwDataSize  //      
                             );

/************************************************************************
*       BYTE,    *
************************************************************************/
void PrintDotSeparatedByteValue( IN LPTSTR lpszText, //     
                                 IN BYTE   btValue1, //    BYTE
                                 IN BYTE   btValue2  //    BYTE
                                );

/************************************************************************
*      DWORD                         *
************************************************************************/
void PrintDwordWithString( IN LPTSTR lpszText, //     
                           IN DWORD  dwValue   //   DWORD
                          );

/************************************************************************
*    DWORD                                       *
************************************************************************/
void PrintDword( IN DWORD dwValue //   DWORD
                );

/************************************************************************
*                                                      *
************************************************************************/
void PrintString( IN LPTSTR lpszString //     
                 );

/************************************************************************
*        ""                 *
************************************************************************/
void PrintTextWithTab( IN LPTSTR lpszString //     
                      );

/************************************************************************
*      ""                             *
************************************************************************/
void PrintTab();

/************************************************************************
*         ""  *
************************************************************************/
void IncreaseTab( IN DWORD dwIncrement  //   "",     
                 );

/************************************************************************
*         ""  *
************************************************************************/
void DecreaseTab( IN DWORD dwDecrement  //   "",     
                 );

/************************************************************************
*                      *
************************************************************************/
void PrintDone(); 

/************************************************************************
*                                *
************************************************************************/
void PrintLastError( IN LPTSTR lpszErrorMessage,  //       
                     IN DWORD  dwErrorCode        //   
                    );

#endif //COMMON_H